/*
 * NoneStallingPipeline.java
 * 
 * Implements a non-pipelined timing model.
 * Each instruction will be scheduled when the previous finishes.
 */
package risc.emulator;

import risc.Opcode;
import risc.RISC;
import risc.CodeWriter;
import risc.StringHelper;


public class NoneStallingPipeline extends Pipeline
{
	public NoneStallingPipeline() 
	{
		this.stallCounter =  new long[RISC.opcode_count];
		this.r = new int[2];
	}

	public int schedule(int ir,int time) 
	{
		int opcode = RISC.Helper.op(ir);
		int done = r[1] + Opcode.codes[opcode].cost;

		r[1] = done;
  		return done;
	}
}
