package risc.emulator;

public abstract class Pipeline 
{
	protected int[] r;
	protected long[] stallCounter; 

	abstract public int schedule(int ir,int time);

	protected int read(int i) 
	{
		return i > 0 ? r[i] : 0;
	}

	public int finish_time() 
	{
		int time=0;
		// We do not need to wait for register 0, start with r1
		for(int i = 1; i < r.length; i++) 
		{
			if (read(i) > time) time = read(i);
		}
		return time;
	}

	public long stall_time(int op) 
	{
		return stallCounter[op];
	}
}

